package com.zcloud.domain.gatewayimpl;

import com.zcloud.domain.domain.gateway.DomainGroupGateway;
import com.zcloud.domain.domain.model.DomainGroupE;
import com.zcloud.domain.persistence.dataobject.DomainGroupDO;
import com.zcloud.domain.persistence.repository.DomainGroupRepository;
import com.zcloud.gbscommon.utils.Tools;
import lombok.AllArgsConstructor;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;

import java.util.Collections;

/**
 * web-infrastructure
 *
 * @Author zhaokai
 * @Date 2026-01-27 11:29:27
 */
@Service
@AllArgsConstructor
public class DomainGroupGatewayImpl implements DomainGroupGateway {
    private final DomainGroupRepository domainGroupRepository;

    @Override
    public Boolean add(DomainGroupE domainGroupE) {
        if(StringUtils.isEmpty(domainGroupE.getDomainGroupId())){
            domainGroupE.setDomainGroupId(Tools.get32UUID());
        }
        DomainGroupDO d = new DomainGroupDO();
        BeanUtils.copyProperties(domainGroupE, d);
        domainGroupRepository.save(d);
        return true;
    }

    @Override
    public Boolean update(DomainGroupE domainGroupE) {
        DomainGroupDO d = new DomainGroupDO();
        BeanUtils.copyProperties(domainGroupE, d);
        domainGroupRepository.updateById(d);
        return true;
    }

    @Override
    public Boolean deletedDomainGroupById(Long id) {
        return domainGroupRepository.removeById(id);
    }

    @Override
    public Boolean deletedDomainGroupByIds(Long[] ids) {
        return domainGroupRepository.removeByIds(Collections.singletonList(ids));
    }
}

